#!/usr/bin/perl
##############################################################################
## Author      # Avi Mittal
## Description # This script conditions the vhdl file, to be used by
##             # vhdlgrep.pl and genDependencyList.pl 
##############################################################################
##   Date   #   Who    # Version # Details
##############################################################################
## 23/04/08 #  Avi     #    1    # Initial Revision
##############################################################################
## 23/04/08 #  Avi     #    2    # 
##############################################################################

use File::Find;


if($#ARGV < 0) {
  print "ERROR: insufficient fields\n";
  print "Usage:\nlinux_prompt> vhdlalign.pl <vhdl file> [output vhdl file]\n";
  exit;
}

if(!(-f @ARGV[0]))
{
  print "ERROR! Input file  @ARGV[0] does not exists. . . Exiting\n";
  exit;
}

$ff = "$ARGV[0]";
@ffs = split(/\//, $ff);
$out_file_name = pop(@ffs);
#f#print "file name minus path = $out_file_name,array = @ffs,orig argv0 = $ff\n";
$line_number = 0;
open(out,">@ARGV[0]_aligned") || die "Could not open mapfile for @ARGV[0].aligned.vhd\n" ;
  open(infile0,"<$ff") || die "Couldnft open infile0. $ff\n ";
  #system("awk f/module/,/endmodule/f @ARGV[0]>@ARGV[0].module")
  while ($line0 = <infile0>) 
  {
    chomp($line0);
    $line_number ++;
    $line0 =~ s/^/ /g;          #add a space at start
    $line0 =~ s/$/ /g;          #add a space at end
    $line0 =~ s/\-\-.*//g;      #remove comments
    $line0 =~ s/;/ ; /g;        #add space
    $line0 =~ s/\(/ \( /g;      #add space
    $line0 =~ s/\)/ \) /g;      #add space
    $line0 =~ s/,/ , /g;        #add space
    $line0 =~ s/:/ : /g;        #add space
    $line0 =~ s/</ < /g;        #add space
    $line0 =~ s/< =/<=/g;       #remove space
    $line0 =~ s/>/ > /g;        #add space
    $line0 =~ s/= >/=>/g;       #remove space
    $line0 =~ s/\t+/ /g;        #No tabs wanted
    $line0 =~ s/\s+/ /g;        #Only single spaces wanted
    if(!($line0 =~ /\S/))       #Skip empty lines
    {
      next;
    }
    $line0 =~ s/;/;\n/g;        #Append a \n to line after ;
    $line0 =~ s/ is / is \n/ig;  #Append a \n to line after is
    $line0 =~ s/ block / block \n/ig;  #Append a \n to line before use
    print out "$line0";
  } #while ($line0 = <infile0>)
