#!/usr/bin/perl
##############################################################################
## Author      # Avi Mittal
## Description # This script extracts meaningful key words from vhdl file
               # making a short file, for the dependency extract to work faster
##############################################################################
##   Date   #   Who    # Version # Details
##############################################################################
## 23/04/08 #  Avi     #    1    # Initial Revision
##############################################################################

use File::Find;


if($#ARGV < 0) {
  print "ERROR: insufficient fields\n";
  print "Usage:\nlinux_prompt> vhdlgrep.pl <vhdl file> [output vhdl file]\n";
  exit;
}

if(!(-f @ARGV[0]))
{
  print "ERROR! Input file  @ARGV[0] does not exists. . . Exiting\n";
  exit;
}

$ff = "$ARGV[0]";
@ffs = split(/\//, $ff);
$out_file_name = pop(@ffs);
#f#print "file name minus path = $out_file_name,array = @ffs,orig argv0 = $ff\n";
$line_number = 0;
open(out,">@ARGV[0]_greped") || die "Could not open mapfile for @ARGV[0].greped.vhd\n" ;
  open(infile0,"<$ff") || die "Couldnft open infile0. $ff\n ";
  #system("awk f/module/,/endmodule/f @ARGV[0]>@ARGV[0].module")
  while ($line0 = <infile0>) 
  {
    chomp($line0);
    $line_number ++;
    if($line0 =~ /( generate )|( process )|( signal )|( block )/i)       #drop generate statement
    {
      next;
    }
    if($line0 =~ /( configuration )|( package )| ( entity )|( architecture )|( library )|( use )|((\w+)(\s+)(:)(\s+)(\w+).*(port\s+map))/i)       #grep only important items
    {
      $line0 =~ s/port\s+map.*/port map/ig;
      print out "$line0\n";
      next;
    }
  } #while ($line0 = <infile0>)
